<template>
  <v-layout align-start class="writing-activity-wrapper">
    <writing-activity
      @reaction="reaction"
      @feedbackContinue="feedbackContinue"
      @retry="retry"
      @check="check"
      @help="help"
      @exit="exit"
      :text.sync="text"
      :activeTab.sync="activeTab"
      :feedback="feedback"
      :progress="progress"
      :activity="activity"
      :loading="loading"
      :stationName="stationName"
      v-if="activity.id"
    />
  </v-layout>
</template>

<script>
import WritingActivity from '../components/Activity/Index';
import Activity from '../Entity/Activity/Activity';
import Feedback from '../Entity/Feedback/Feedback';
import ActivityFactory from './Entity/ActivityFactory';
import Progress from '../Entity/Activity/Progress';

export default {
  props: {
    withVApp: {
      type: Boolean,
      default: true,
    },
    preview: {
      type: Boolean,
      default: false,
    },
    activityReceived: {
      type: Object,
      default: () => new Activity(),
    },
    feedbackReceived: {
      type: Object,
      default: () => new Feedback(),
    },
    writingId: {
      type: String,
      default: () => '',
    },
    sequenceId: {
      type: String,
      default: () => '',
    },
    httpService: {
      type: Function,
    },
    stationName: {
      type: String,
      default: () => '',
    },
  },
  components: {
    WritingActivity,
  },
  data() {
    return {
      text: '',
      activeTab: 0,
      loading: false,
      feedback: new Feedback(),
      activity: new Activity(),
      progress: new Progress(),
      activityFactory: {},
    };
  },

  methods: {
    init() {
      this.activityFactory = new ActivityFactory(
        this.getPropsToFactory(),
        this.httpService,
      );
      if (!this.preview) {
        this.getActivity();
        return;
      }
      this.previewMode();
    },
    getPropsToFactory() {
      return {
        writingId: this.writingId,
        sequenceId: this.sequenceId,
        activityReceived: this.activityReceived,
        feedbackReceived: this.feedbackReceived,
      };
    },
    previewMode() {
      this.text = '';
      this.activityFactory.getActivity().then((data) => {
        this.activity = new Activity(data);
      });
    },
    getActivity() {
      this.text = '';
      this.activityFactory.getActivity().then((data) => {
        this.activity = new Activity(data);
        this.getProgress(this.activity.id);
      });
    },
    getActivityById(id) {
      this.text = '';
      this.activityFactory.getActivityById(id).then((data) => {
        this.activity = new Activity(data);
        this.getProgress(this.activity.id);
      });
    },
    getProgress(writingId, hasCheckAwnser = false) {
      this.activityFactory.getProgress(writingId).then((data) => {
        this.progress = new Progress(data);
        if (this.canGetFeedback && !hasCheckAwnser) {
          this.getFeedbackByWritingId(this.activity.id);
        }
      });
    },
    getFeedbackByWritingId(id) {
      this.activityFactory.getFeedbackByWritingId(id).then((data) => {
        this.activeTab = 2;
        this.feedback = new Feedback(data);
        this.text = this.feedback.sentence;
      });
    },
    toggleFeedback() {
      if (this.progress.step === 2) {
        this.feedback.toggleFeedback(true);
      }
    },
    validateAnswer() {
      this.activityFactory
        .checkAnswer(this.activity.id, this.text)
        .then((data) => {
          this.feedback = new Feedback(data);
          this.activeTab = 2;
          this.toggleFeedback();
          this.getProgress(this.activity.id, true);
          this.loading = false;
        });
    },
    previewAnswer() {
      this.activityFactory
        .previewAnswer(this.text, this.activityReceived)
        .then((data) => {
          this.feedback = new Feedback(data);
          this.toggleFeedback();
          this.loading = false;
        });
    },
    check() {
      if (this.loading) {
        return;
      }
      this.loading = true;
      if (this.preview) {
        this.previewAnswer();
        return;
      }
      this.validateAnswer();
    },
    retry() {
      this.getActivityById(this.activity.id);
      this.activeTab = 0;
      this.feedback = new Feedback();
    },
    help() {
      this.$emit('help');
    },
    exit() {
      this.$emit('exit');
    },
    feedbackContinue() {
      this.text = '';
      if (this.preview) {
        this.$emit('feedbackContinue');
        return;
      }
      this.activityFactory
        .getActivityBySequence(this.sequenceId)
        .then((data) => {
          this.activity = new Activity(data);
          this.feedback = new Feedback();
          this.getProgress(this.activity.id);
        })
        .catch((err) => {
          if (err.response.data.status === 404) {
            this.$emit('feedbackContinue');
          }
        });
    },
    reaction(data) {
      this.$emit('evaluate', data);
    },
  },
  computed: {
    canGetFeedback() {
      return this.progress.concluded || this.progress.step === 2;
    },
  },
  mounted() {
    this.init();
  },
};
</script>
<style lang="sass">
  @import ~@/styles/defaults/mobileFirst
  .writing-activity-wrapper
    width: 100%
    user-select: none
    background: #fff
    +media-min-lg()
      background: url('https://static.cnago.com.br/activities/img/writing/background.svg')
      height: auto
      overflow: inherit
</style>
